//--------------------------------------------------------------
// File     : main.c
// Datum    : 23.10.2013
// Version  : 1.0
// Autor    : UB
// EMail    : mc-4u(@)t-online.de
// Web      : www.mikrocontroller-4u.de
// CPU      : STM32F429
// IDE      : CooCox CoIDE 1.7.4
// GCC      : 4.7 2012q4
// Module   : CMSIS_BOOT, M4_CMSIS_CORE
// Funktion : Hauptprogramm
// Hinweis  : Diese zwei Files muessen auf 8MHz stehen
//              "cmsis_boot/stm32f4xx.h"
//              "cmsis_boot/system_stm32f4xx.c"
// In Configuration diese Define hinzufgen :
// "STM32F429_439xx" , "__ASSEMBLY__" , "USE_STDPERIPH_DRIVER"
//--------------------------------------------------------------

#include <stdlib.h>
#include "main.h"
#include "stm32f4xx_gpio.h"
#include "stm32f4xx_rcc.h"
#include "stm32f4xx_dma.h"
#include "misc.h"

#include "globals.h"
#include "defines.h"
volatile u16 *pt=((uint32_t)0xD0000000);
volatile u16 *px=((uint32_t)0xD0000000);
volatile u32 *py=((uint32_t)0xD0000000);
#include "tm_stm32f4_spi.h"
#include "tm_stm32f4_spi_c.h"
#include "tm_stm32f4_ili9341.h"
#include "tm_stm32f4_ili9341_c.h"
#include "colors.h"
#include "new_lib_fonts.h"
#include "new_lib_glcd.h"
#include "kklcdxx.h"

/**/
#include "stm32_ub_sdram.h"
#include "timer_delay_etc.h"
#include "stm32_ub_systick.h"
#include "stm32_ub_systick_c.h"


#include "stm32f4xx_dcmi.h"

#include "kk_dcmi.h"
#include "kk_sccbc.h"



#include "enc28j60.h"
#include "enc28j60_c.h"



void enc_spiinit(void){
	TM_SPI_Init(SPI2, TM_SPI_PinsPack_2);
}



int main(void){
	  uint32_t n,tmp, adr,i,zl=0;
  SystemInit(); // Quarz Einstellungen aktivieren
  init_gpio2rcc();
  init_led();
   //cam_init();
//   cam_InitNVIC();
   UB_SDRAM_Init();

   for(adr=0;adr<4000000;adr+=2) UB_SDRAM_Write16b(adr,1000);
    for(adr=12800;adr<25600;adr+=2)  UB_SDRAM_Write16b(adr,YELLOW);
   for(adr=64000;adr<76800;adr+=2)UB_SDRAM_Write16b(adr,BLACK);
    for(adr=294400*2;adr<307200*2;adr+=2)UB_SDRAM_Write16b(adr,GREEN);


   TM_SPI5_Init(TM_SPI_PinsPack_1);
   TM_ILI9341_Init();
 kk_ILI9341_Fill_y(640,480);
 enc_spiinit();
 cam_InitXCLK();
 cam_powerUpSeq();
 cam_init_sccb_io();
 cam_sccb_init();

 //tmp= OV7670_init();
// tmp=restest();

#if 0
h_px=1024;v_px=768;
tmp=set_cam_register(reg_datei);
#else
tmp=set_cam_register(reg_datei);
//tmp=sccb_reg_init();
#endif

lgi(5,1,tmp);//wait;






	//tmp= OV3640_init();
lgi(5,5,tmp);//wait;


lgi(5,10,tmp);//wait;
//ov3640_change_dim_config();
 cam_InitIO();
 cam_InitDCMI();
 cam_InitDMA();
 DMA2Stream1_InitNVIC();

wait;

//xset( list);

  while(1)
  {

	  cam_CaptureStart();
		 kk_ILI9341_Fill_y(h_px,v_px);
		 zl++;
	 wait;

if(zl==10){
	h_px=1024;v_px=768;
	tmp=set_cam_register(reg_datei);
//	h_px=640;v_px=480;
//	tmp=set_cam_register(ov3640_vga);
//	tmp=sccb_reg_init();
}

/*	    lg(15,1);
	    lw(" ");li(UB_SDRAM_Read8b(10));
	    lw("-");li(UB_SDRAM_Read8b(11));
	    lw(" ");li(UB_SDRAM_Read8b(12));
	    lw("-");li(UB_SDRAM_Read8b(13));
	    lw(" ");li(UB_SDRAM_Read8b(14));
	    lw("-");li(UB_SDRAM_Read8b(15));
	    lw(" ");li(UB_SDRAM_Read8b(16));
	    lw("-");li(UB_SDRAM_Read8b(17));
	    lw(" ");li(UB_SDRAM_Read8b(18));
	    lg(16,1);
	    lw("-");li(DCMI->DR);*/

wait;
//GPIOG->ODR ^= GPIO_Pin_13; // PG13 toggeln
GPIOG->ODR ^= GPIO_Pin_14; // PG13 toggeln
led1_tog;
  }
}
